#include <stdio.h> /* para printf() */
#include <conio.h> /* para getch() */

typedef int XYCOORD;

XYCOORD xa, ya, xb, yb, xc, yc, xmax, ymax, xmin, ymin, beta;

void DefineTriangulo(XYCOORD x1, XYCOORD y1, XYCOORD x2, XYCOORD y2, XYCOORD x3, XYCOORD y3)
{
   xmax= xmin= xa = x1;
   ymax= ymin= ya = y1;
   xb = x2;
   if (xb>xmax) xmax=xb;
   else if (xb<xmin)   xmin= xb;
   yb = y2;
   if (yb>ymax) ymax=yb;
   else if (yb<ymin) ymin= yb;
   xc = x3;
   if (xc>xmax) xmax=xc;
   else if (xc<xmin) xmin= xc;
   yc = y3;
   if (yc>ymax) ymax=yc;
   else if (yc<xmin) ymin= yc;
   beta = ya*(xc-xb)+yb*(xa-xc)+yc*(xb-xa);
   printf("[2D]Triangulo= (%3d, %3d) (%3d, %3d) (%3d, %3d)\n",\
       xa, ya, xb, yb, xc, yc);
}

int TestaPonto(XYCOORD xe, XYCOORD ye)
{
   printf("[2D]Ponto testado: %d %d\n", xe, ye);
   if ((xe>xmax)||(xe<xmin)||(ye>ymax)||(ye<ymin))
      return 0;
   if (beta > 0) {
      if ((yb*(xe-xc)+yc*(xb-xe)+ye*(xc-xb)) < 0)
         return 0;
      if ((ya*(xc-xe)+yc*(xe-xa)+ye*(xa-xc)) < 0)
         return 0;
      if ((ya*(xe-xb)+yb*(xa-xe)+ye*(xb-xa)) < 0)
         return 0;
   }
   else {
      if ((yb*(xe-xc)+yc*(xb-xe)+ye*(xc-xb)) > 0)
         return 0;
      if ((ya*(xc-xe)+yc*(xe-xa)+ye*(xa-xc)) > 0)
         return 0;
      if ((ya*(xe-xb)+yb*(xa-xe)+ye*(xb-xa)) > 0)
         return 0;
   }
   return 1;
}


/* Comentarios aa funcao TestaIntersec()

>>> Valor retornado <<<
Retorna 1 caso haja inteseccao segmento-triangulo 0 caso contrario.

>>> Definicoes <<<
Plano suporte do triangulo: plano definido pelos tres pontos do
triangulo.
Reta suporte do segmento: reta definida pelos dois pontos do
segmento de reta.

>>> + ou - como funciona <<<
1. [3D] Dados os tres pontos do triangulo calcular a equacao do
plano suporte do triangulo (Geometria Analitica) e da reta suporte
do segmento (matematica 2o grau: funcoes parametricas).
2. [3D] Calcular o ponto de interseccao reta-plano (Geometria
Analitica).
3. [3D->2D] Projetar no plano coordenado x-z ou x-z ou x-y, aquele
que for "projetavel" primeiro, tanto o triangulo quanto o ponto de
interseccao.
4. [2D] Testar se a projecao do ponto pertence aa projecao do
triangulo, ou seja, se esta "dentro" do triangulo projetado,
utilizando combinacao convexa (Algebra Linear).

>>> Observacoes <<<
1. Nao otimizei praticamente nada, assim, caso alguem o faca,
por favor, contacte-me...
2. Testei muito pouco, problemas, falhas, sugestoes, perguntas, por
favor, contacte-me...
3. rymaedaARROBAyahoo.com
4. Costumo utilizar inteiros nos calculos, **acho** que no meu
Pentium (I) e' mais rapido.
5. As coordenadas do ponto de interseccao sao calculadas com:
   xi= (xa*(bp*yb+cp*zb)-xb*(bp*ya+cp*za+dp))/Alpha
   yi= (ya*(ap*xb+cp*zb)-yb*(ap*xa+cp*za+dp))/Alpha
   zi= (za*(ap*xb+bp*yb)-zb*(ap*xa+bp*ya+dp))/Alpha

>>> Bibliografia <<<
1. Livro de Geometria Analitica: "aquele um" classico do Alfredo
Steinbruch.
2. Sobre combinacao convexa existe uma explicacao boa no livro de
Programacao Linear do Abelardo Puccini. Mas antes e' preciso conhecer
aquela abstracaozinha matematica chamada vetor (Geometria Analitica).

*/

int TestaIntersec3D(
   XYCOORD x1, XYCOORD y1, XYCOORD z1, /* vertice 1 do triangulo */
   XYCOORD x2, XYCOORD y2, XYCOORD z2, /* vertice 2 do triangulo */
   XYCOORD x3, XYCOORD y3, XYCOORD z3, /* vertice 3 do triangulo */
   XYCOORD xr1, XYCOORD yr1, XYCOORD zr1,/* ponto 1 do segmento */
   XYCOORD xr2, XYCOORD yr2, XYCOORD zr2)/* ponto 2 do segmento */
{
   XYCOORD ap= (y1-y3)*(z2-z3)-(z1-z3)*(y2-y3); /* Calculo dos coeficientes da equacao */
   XYCOORD bp= (z1-z3)*(x2-x3)-(x1-x3)*(z2-z3); /* do plano: ap*x + bp*y + cp*z +dp =0 */
   XYCOORD cp= (x1-x3)*(y2-y3)-(y1-y3)*(x2-x3); /* definido pelos vertices do triangulo */
   XYCOORD dp= -ap*x1 - bp*y1 - cp*z1;
   XYCOORD Alpha, Gamma;
   XYCOORD xb= xr2-xr1;
   XYCOORD yb= yr2-yr1;
   XYCOORD zb= zr2-zr1;
   XYCOORD xa= xr1;
   XYCOORD ya= yr1;
   XYCOORD za= zr1;

   printf("[3D]Triangulo (%3d,%3d,%3d)(%3d,%3d,%3d)(%3d,%3d,%3d)\n",x1,y1,z1,x2,y2,z2,x3,y3,z3);
   printf("[3d]Segmento (%3d,%3d,%3d)(%3d,%3d,%3d)\n", xr1, yr1, zr1, xr2, yr2, zr2);
   if (Alpha= ap*xb+bp*yb+cp*zb){ /* reta e o plano possuem somente um ponto de interseccao? */
      Gamma= ap*xa+bp*ya+cp*za+dp;
      if (Gamma>0)               /* a interseccao */
         if (Gamma>Alpha)        /* ocorre entre */
            return 0;            /* os extremos */
         else if (Gamma<Alpha)   /* do segmento? */
            return 0;
      if (ap){                     /* Triangulo "projetavel" em y-z? */
         printf("Projecao em y-z: ");
         DefineTriangulo(y1 ,z1 ,y2 ,z2 ,y3 ,z3);
         return TestaPonto((ya*(ap*xb+cp*zb)-yb*(ap*xa+cp*za+dp))/Alpha, (za*(ap*xb+bp*yb)-zb*(ap*xa+bp*ya+dp))/Alpha);
      }
      else if (bp){               /* Triangulo "projetavel" em x-z? */
         printf("Projecao em x-z: ");
         DefineTriangulo(x1 ,z1 ,x2 ,z2 ,x3 ,z3);
         return TestaPonto((xa*(bp*yb+cp*zb)-xb*(bp*ya+cp*za+dp))/Alpha, (za*(ap*xb+bp*yb)-zb*(ap*xa+bp*ya+dp))/Alpha);
      }
      else {               		/* Triangulo >>tem<< que ser "projetavel" em x-y */
         printf("Projecao em x-y: ");
         DefineTriangulo(x1 ,y1 ,x2 ,y2 ,x3 ,y3);
         return TestaPonto((xa*(bp*yb+cp*zb)-xb*(bp*ya+cp*za+dp))/Alpha, (ya*(ap*xb+cp*zb)-yb*(ap*xa+cp*za+dp))/Alpha);
      }
   }

   return 0; /* Ou o segmento  paralelo ao plano do triangulo, */
             /* ou o segmento pertence ao plano do triangulo, */
             /* ou os tres pontos do "triangulo" sao no minimo colineares */
}

int main(void){
   printf("Resultado do teste: %d\n\n",TestaIntersec3D(
      100,0,0, /* triangulo: vertice 1 */
      0,100,0, /* triangulo: vertice 2 */
      0,0,100, /* triangulo: vertice 3 */
      0,0,0, /* segmento: ponto 1 */
      100,100,100 /* segmento: ponto 2 */
      ));
   printf("Resultado do teste: %d\n\n",TestaIntersec3D(
      100,0,0, /* triangulo: vertice 1 */
      0,100,0, /* triangulo: vertice 2 */
      0,0,100, /* triangulo: vertice 3 */
      0,0,0, /* segmento: ponto 1 */
      -100,100,100 /* segmento: ponto 2 */
      ));
   printf("Resultado do teste: %d\n\n",TestaIntersec3D(
      0,100,0, /* triangulo: vertice 1 */
      0,0,100, /* triangulo: vertice 2 */
      100,0,100, /* triangulo: vertice 3 */
      0,0,0, /* segmento: ponto 1 */
      100,1000,100 /* segmento: ponto 2 */
      ));
   printf("Resultado do teste: %d\n\n",TestaIntersec3D(
      0,0,0, /* triangulo: vertice 1 */
      0,0,0, /* triangulo: vertice 2 */
      0,0,0, /* triangulo: vertice 3 */
      0,0,0, /* segmento: ponto 1 */
      100,1000,100 /* segmento: ponto 2 */
      ));
   getch();
   return 0;
}
